# Class URIReferenceException

java.lang.Object
java.lang.Throwable
java.lang.Exception
javax.xml.crypto.URIReferenceException

All Implemented Interfaces:
  `Serializable`

public class URIReferenceException extends Exception
Indicates an exceptional condition thrown while dereferencing a `URIReference`.

A `URIReferenceException` can contain a cause: another throwable that caused this `URIReferenceException` to get thrown.

Since:
  1.6
See Also:
  - `URIDereferencer.dereference(URIReference, XMLCryptoContext)`
  - `RetrievalMethod.dereference(XMLCryptoContext)`
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`URIReferenceException()`
Constructs a new `URIReferenceException` with `null` as its detail message.
`URIReferenceException(String message)`
Constructs a new `URIReferenceException` with the specified detail message.
`URIReferenceException(String message, Throwable cause)`
Constructs a new `URIReferenceException` with the specified detail message and cause.
`URIReferenceException(String message, Throwable cause, URIReference uriReference)`
Constructs a new `URIReferenceException` with the specified detail message, cause and `URIReference`.
`URIReferenceException(Throwable cause)`
Constructs a new `URIReferenceException` with the specified cause and a detail message of `(cause==null ? null : cause.toString())` (which typically contains the class and detail message of `cause`).

## Method Summary

Modifier and Type
Method
Description
`Throwable`
`getCause()`
Returns the cause of this `URIReferenceException` or `null` if the cause is nonexistent or unknown.
`URIReference`
`getURIReference()`
Returns the `URIReference` that was being dereferenced when the exception was thrown.
`void`
`printStackTrace()`
Prints this `URIReferenceException`, its backtrace and the cause's backtrace to the standard error stream.
`void`
`printStackTrace(PrintStream s)`
Prints this `URIReferenceException`, its backtrace and the cause's backtrace to the specified print stream.
`void`
`printStackTrace(PrintWriter s)`
Prints this `URIReferenceException`, its backtrace and the cause's backtrace to the specified print writer.

### Methods declared in class Throwable

`addSuppressed, fillInStackTrace, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, initCause, setStackTrace, toString`
Modifier and Type
Method
Description
`final void`
`addSuppressed(Throwable exception)`
Appends the specified exception to the exceptions that were suppressed in order to deliver this exception.
`Throwable`
`fillInStackTrace()`
Fills in the execution stack trace.
`String`
`getLocalizedMessage()`
Creates a localized description of this throwable.
`String`
`getMessage()`
Returns the detail message string of this throwable.
`StackTraceElement[]`
`getStackTrace()`
Provides programmatic access to the stack trace information printed by `Throwable.printStackTrace()`.
`final Throwable[]`
`getSuppressed()`
Returns an array containing all of the exceptions that were suppressed, typically by the `try`-with-resources statement, in order to deliver this exception.
`Throwable`
`initCause(Throwable cause)`
Initializes the cause of this throwable to the specified value.
`void`
`setStackTrace(StackTraceElement[] stackTrace)`
Sets the stack trace elements that will be returned by `Throwable.getStackTrace()` and printed by `Throwable.printStackTrace()` and related methods.
`String`
`toString()`
Returns a short description of this throwable.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Constructor Details

### URIReferenceException

public URIReferenceException()
Constructs a new `URIReferenceException` with `null` as its detail message.

### URIReferenceException

public URIReferenceException(String message)
Constructs a new `URIReferenceException` with the specified detail message.

Parameters:
  `message` - the detail message

### URIReferenceException

public URIReferenceException(String message, Throwable cause)
Constructs a new `URIReferenceException` with the specified detail message and cause.

Note that the detail message associated with `cause` is not automatically incorporated in this exception's detail message.

Parameters:
  `message` - the detail message
  `cause` - the cause (A `null` value is permitted, and indicates that the cause is nonexistent or unknown.)

### URIReferenceException

public URIReferenceException(String message, Throwable cause, URIReference uriReference)
Constructs a new `URIReferenceException` with the specified detail message, cause and `URIReference`.

Note that the detail message associated with `cause` is not automatically incorporated in this exception's detail message.

Parameters:
  `message` - the detail message
  `cause` - the cause (A `null` value is permitted, and indicates that the cause is nonexistent or unknown.)
  `uriReference` - the `URIReference` that was being dereferenced when the error was encountered
Throws:
  `NullPointerException` - if `uriReference` is `null`

### URIReferenceException

public URIReferenceException(Throwable cause)
Constructs a new `URIReferenceException` with the specified cause and a detail message of `(cause==null ? null : cause.toString())` (which typically contains the class and detail message of `cause`).

Parameters:
  `cause` - the cause (A `null` value is permitted, and indicates that the cause is nonexistent or unknown.)

## Method Details

### getURIReference

public URIReference getURIReference()
Returns the `URIReference` that was being dereferenced when the exception was thrown.

Returns:
  the `URIReference` that was being dereferenced when the exception was thrown, or `null` if not specified

### getCause

public Throwable getCause()
Returns the cause of this `URIReferenceException` or `null` if the cause is nonexistent or unknown. (The cause is the throwable that caused this `URIReferenceException` to get thrown.)

Overrides:
  `getCause` in class `Throwable`
Returns:
  the cause of this `URIReferenceException` or `null` if the cause is nonexistent or unknown.

### printStackTrace

public void printStackTrace()
Prints this `URIReferenceException`, its backtrace and the cause's backtrace to the standard error stream.

Overrides:
  `printStackTrace` in class `Throwable`

### printStackTrace

public void printStackTrace(PrintStream s)
Prints this `URIReferenceException`, its backtrace and the cause's backtrace to the specified print stream.

Overrides:
  `printStackTrace` in class `Throwable`
Parameters:
  `s` - `PrintStream` to use for output

### printStackTrace

public void printStackTrace(PrintWriter s)
Prints this `URIReferenceException`, its backtrace and the cause's backtrace to the specified print writer.

Overrides:
  `printStackTrace` in class `Throwable`
Parameters:
  `s` - `PrintWriter` to use for output